globals
[

  knowledge-transfer
  ;List that saves the numbert of attendees based on their experience (location in list indicates the experience and the value is the number)
  n-attend
  ;Predicted system profit
  pred-sys-profit
  ;The number of skilled agents hired by big and small companies, respectively. The location in list indicates the skill from lower to higher degree. The value indicates the number of agents.
  incb
  incs
  ;It hold the number of agents who completed the programme in the current iteration.
  n-finished
  ;It holds the percentage of programme completion
  per-success
  ; These hold the number of agents with different skills.
  no-edex
  no-edg
  no-ex
  no-g
  no-b
  ;The paid premium.
  premium
  ;probability of an agent gets hired in a good training policy
  p-hg
  ;probability of an agent gets hired in a bad training policy
  p-hb
  ;number of agents with/without education (ed/-) with excellent/good skills (ex/g) who got hired by big/small companies (b/s)
  edexb
  edexs
  edgb
  edgs
  exb
  exs
  gb
  gs
  ;expected revenue of trained agents in big/small comapnies (list)
  lb
  ls
  ;Unsatisfied demand for skilled agents by big/small companies
  ds
  db
  ;a list that keeps supply of each skill per iteration
  dummy-supply
  ;a list that keeps demand for each skill per iteration
  demand
  ;a list that keeps the number of unhired agents for each skill per iteration
  supw
  ;;probaiblity of finding a good in unemployed market min {(average of last three years # unemployed and good/ average of last three years #demand for good) , 1}
  pgn
  ;; probaiblity of finding an educated in unemployed market min{ (average of last three years # unemployed and educated/ average of last three years #demand for educated),1}
  pedn
  ;;probaiblity of finding an excellent in unemployed market min{ (average of last three years # unemployed and excellent/ average of last three years #demand for excellent),1}
  pexn
  ;p-tr ;;;;is probabibility of being a trainer
  p-tr
  ;;probaiblity of having different skills and stay to be hired (# hired from trainees and certain skills(big companies)/ # trainees(big companies))
  pextb
  pedextb
  pedgtb
  pgtb
  ;;Pexts, Pedts , Pgts are defined the same as before for small companies
  pedts
  pexts
  pgts
  ;wages for different skills
  wedex
  wedg
  wg
  wex
  ;probability of having unemployed skilled agents (big/small) when training agents using a good/bad policy (for artisans)
  p-ovgb
  p-ovbb
  p-ovgs
  p-ovbs
  ;profit of leaving the programme and looking for a job
  prof-lj
  ;probability of finding a job with/without education and good/excellent skills
  pfjedex
  pfjex
  pfjedg
  pfjg
  ;excessive costs of good training
  costg
  ;profit of training
  prof
  ;probability of finding a job
  p-fj
  demandrate
]

;here we define apprentices
breed[apprentices apprentice]
apprentices-own[
  ;alpha in n years -- used to calculate alphas for n != training/whole
  alphan
  ;impact of discount factor in the training years
  alphatraining
  ;impact of discount factor in the whole horizon
  alphaT
  ;discount factor per year
  alpha
  ;years unemployed
  wud
  ;predicted profit
  pred-prof
  ;predicted degree of work-based skills
  pred-s-w
  ;predicted degree of school-based skills
  pred-s-ed
  ;if an ajent can afford to pay the costs
  aafordable?
  ;costs of training agents
  traincost
   ;degree of work-based skilled
  s-w
  ;degree of school-based skilled
  s-ed
  ;attinability for work-based skills
  talent-w
  ;attinability for school-based skills
  talent-ed
  ;wealth of the family
  wealth
  ;years spent in the apprenticeship programme
  year-in-apprent
  ;training place (e.g. a big company or a contractor)
  tarining-place
  ;is spending the progeramme profitable
  profitable?
  ;passion for attaining the skill
  passion
  ;chance of enrolement in the programme; randomely generated based on the passion
  chance
  ; the training scheme of the company
  howtrained
]
breed[companies company]
companies-own[
  ;see apprentices
  alpha
  alphan
  alphatraining
  alphaT
  ;policy of training
  howtrain?
  ;the unique id to identify them
  id
  ;profitn is profit obtained by not training
  profitn
  ;traininc is considered for companies
  traininc
  ;profitg is profit obtained by good/bad training
  profitg
  profitb
  ;size of the company big/small
  mysize
  ;list of profits for different decisions
  decisionlist
  ;if the company needs a skilled agent
  need?
  ;hiring policy --- 0 not hiring, 1 hire from the market, 2 hire from the own trainees
  hire
  ;it decides about the priority of companies
   chance
  ;capacity for training
  capacity
  ;if the company trained any agents
  trained?

]
undirected-link-breed [cfs cf]
to setup
  clear-all
  make-globals
  ; make-apprentices
  ;sweepingsetup
  make-trainers
  check-affordability
  reset-ticks
end
; assign values to global variables
;to sweepingsetup



 ; Iwnedex
  ;Iwedex
  ;Iwnedg
  ;Iwedg
  ;Iwex
  ;Iwg
  ;Check
;end



to make-globals
  set incb (list 0 0 0 0)
  set incs (list 0 0 0 0)
  set n-attend (list 0 0 0)
  set edexb 0
  set edexs 0
  set edgb 0
  set edgs 0
  set exb 0
  set exs 0
  set ds 0
  set db 0
  set gb 0
  set gs 0
  set lb (list 0 0 0 0)
  set ls (list 0 0 0 0)
  set supw (list 0 0 0 0)
  set demand (list 0 0 0 0)
  set dummy-supply (list 0 0 0 0)
  let sdfd random-float .5
  ; To initiate the simulation we assume that
  set p-hg 0.5 + sdfd
  set p-hb (1 - BadTrainingOnSpeed) * p-hg
  set pgtb random-float 1
  set pgts random-float pgtb
  ;We consider these as equally probable events (i.e. initially the trainers assume these probabilities are the same; however, they revise it over time)
  set pgn random-float pgts

  set pexn .5
  ifelse school-or-knowledge [
  set pedextb random-float 1
    set pedgtb random-float 1
    set pgtb random-float .9
    set pextb random-float .9
    set pedts random-float 1
  ]
  [
 set pedextb random-float .9
    set pedgtb random-float .9
    set pgtb random-float .9
    set pextb random-float .9
    set pedts random-float .9
  ]

 set pedn random-float pedts
  set pexn random-float pextb
  set pextb random-float 1
  set pexts random-float pextb


  set p-tr .1
  ifelse Trainer-type < 2[ set wedex Iwedex
    set wedg Iwedad
  set wg  Iwnedad
    set wex Iwnedex]
  [
   set wg Iwad
   set wex  Iwex
  ]
  set p-ovgb random-float 1
  set p-ovbb (1 - BadTrainingOnSpeed) * p-ovgb
  set p-ovgs random-float p-ovgb
  set p-ovbs (1 - BadTrainingOnSpeed) * p-ovgs
  set prof-lj 0
  ifelse Trainer-type  < 2
  [set pfjedex random-float 1
    set pfjex random-float (1 - pfjedex)
    set pfjedg random-float (1 - (pfjedex + pfjex))
    set pfjg random-float (1 - (pfjedex + pfjex + pfjedg))]
  [
    set pfjex random-float 1
    set pfjg random-float (1 - pfjex)
  ]
  ;profit and costs for contractors
  set prof .8
  set costg .6
  ;rate of demand in an artisan society
  set demandrate .6


    ifelse (prepayment )
    [
      set premium 3

    ]
    [
      set premium 0

    ]

  ifelse Trainer-type = 2
  [set p-fj min (list 1 (pfjex + pfjg))]
  [set p-fj min (list 1 (pfjex + pfjg + pfjedex + pfjedg))]
end
;;create trainers
to make-trainers
  ifelse Trainer-type != 1
  [
    create-companies (number-of-big-companies  + NumberOfSmallCompanies)
    [

      set id who + 1
      set profitn 0
      set alpha random-normal alphaMu ( (1 - alphaMu) / 3)
      set traininc 0
      ifelse NoUnion[
      ;;in scenario 2 all small companies will participate in training as well
        set howtrain? 2]
      [
      ;;for scenario 1 no small company will train
      set howtrain? 0
      ]

      if (Trainer-type = 2)
          [

            set howtrain? random 3
            ifelse prepayment
            [set traininc 3]
           [set traininc 0]
                 ]
      set profitg 0
      set mysize "small"

        set capacity 1
        set chance  random-float .5
      set decisionlist (list 0)
      set need? 1
      set hire (list 1 1 1)
      set profitb 0
      set trained? 0
    ]
   ask n-of number-of-big-companies companies[
      set mysize "big"
      set howtrain? 2
      if (Trainer-type = 0)
      [set capacity 5]
      set chance .5 + random-float .5
      set hire (list 2 2 2)
      set need? 0
      if (Trainer-type = 2)
          [set howtrain? random 3
            ifelse prepayment
            [set traininc 3]
           [set traininc 0]
      ]

    ]

  ]
  [
    create-companies 10
    [
      set howtrain? random 3
      set id who + 1
      set profitn 0
      set alpha random-normal alphaMu ( (1 - alphaMu) / 3)
      set traininc 0

      set profitg 0
      set mysize "small"
      ;;trainers capacity 12 for scenario 1 and 20 for scenario 2
      ifelse NoUnion
        [set capacity 20]
      [set capacity 12]
      set chance  random-float 1
      set decisionlist (list 0)
      set need? 0
              let idummy 1
      ifelse (Trainer-type = 0)
      [set hire []


    while [idummy <= TrainingYears]
    [set hire fput (2 * random 2) hire
    set idummy idummy + 1]
       ; set hire (list (2 * random 2) (2 * random 2) (2 * random 2))
      ]
      [set hire []
           while [idummy <= TrainingYears]
    [set hire fput (random 3) hire
    set idummy idummy + 1]

   ;       set hire (list (random 3) (random 3) (random 3))
        ]
      set profitb 0
      set trained? 0
    ]
  ]
end
to go



  make-apprentices
  check-affordability
  check-profitability
  start-apprentice
  update-quality
  skill-update
  if ticks > TrainingYears
  [hiring-step
    hiring
     update-profits]

  update-all
  tick
end
;p-tr ;;;;is probabibility of being a trainer
;traininc is considered for companies
;profitg is profit obtained by good training
;profitb is profit obtained by bad training
;profitn is profit obtained by not training
;howtrain? 0 = not 1 = bad 2 = good
to make-apprentices
create-apprentices (NumberOfPotentialTrainees)
  [
    set traincost 0
    set alpha random-normal alphaMu ((1 - alphaMu) / 3)
    set s-w 0
    set s-ed 0
    set talent-w .5 + random-float .5
    set talent-ed random-float 1
    ifelse (random-float 1 <= ShareOfWealthyFamilies )
    [set wealth 3 ]
      [ set wealth 1 ]
    set year-in-apprent 0
    set profitable? 0
    set passion random-float 1
    set chance random-float passion
    set aafordable? 0
    set alpha random-normal alphaMu ((1 - alphaMu) / 3)
    set tarining-place "?"
  ]
end
to start-apprentice
  let l 0
  let m count companies with [howtrain? > 0]
  while [l < m  and (count companies with [trained? = 0] > 0) ]
  [
    ask max-one-of companies with [trained? = 0][chance]
    [
      ifelse howtrain? = 0 [
        set trained? 1
      ][
        ;; id for companies
        let iam id
        ask apprentices with [(aafordable? = 1) and (tarining-place = "?") and (profitable? = 1)  ]
        [set chance random-float passion      ]
        set trained? 1
        let nomb 0
        ifelse count apprentices with [(aafordable? = 1) and (tarining-place = "?") and (profitable? = 1) ] < capacity
        [set nomb count apprentices with [(aafordable? = 1) and (tarining-place = "?") and (profitable? = 1) ] ]
        [set nomb capacity]
        if nomb > 0
        [ask max-n-of nomb apprentices with [(aafordable? = 1) and (tarining-place = "?") and (profitable? = 1) ][chance]
          [set tarining-place [id] of myself
            set howtrained [howtrain?] of myself
        ]]
      ]
    ]
    ifelse companies with [howtrain? > 0] = 0
    [ set l m + 1]
    [ set l l + 1]
  ]
  ask companies [
    set trained? 0
  ]
end
to check-affordability
  ask apprentices [
    ifelse (prepayment and wealth = 3)
    [set aafordable?  1
      set traincost 3
    ]

      [
        ifelse (prepayment)
      [
          set aafordable?  0
        ]
      [
          set aafordable?  1
          set traincost 0
      ]

  ]]
end
to check-profitability
  ask apprentices with [ (tarining-place = "?" and aafordable? = 1)]
  [
    let princ (- traincost)
    let tt 0
    ifelse Trainer-type = 2
    ;;P-TR = 10%


    ;;revise it here
    [
      set tt  TrainingYears + 1
      while [tt <= Horizon]
    [

        if (Trainer-type = 2) [set wedex wex
          set wedg wg ]
        set princ (princ + traincost * (1 - (p-tr ^ (tt - 1 - TrainingYears))) * alpha ^ tt ) ;; the probability of being training increases by experience after finishing programme
      set tt tt + 1
    ]

      ] ;; if it is a craft  apprentice assumes all costs as profit and if it is not half of that
    [
        set tt  TrainingYears + 1
      while [tt <= Horizon]
    [

        if (Trainer-type = 2) [set wedex wex
          set wedg wg ]
        set princ (princ + .5 * traincost * (1 - (p-tr ^ (tt - 1 - TrainingYears))) * alpha ^ tt ) ;; the probability of being training increases by experience after finishing programme
      set tt tt + 1
    ]

]
    let t 1
    while [t <= Horizon]
    [
      ifelse t < TrainingYears + 1
      [set princ (princ - (1 * (alpha ^ t) ))][
        if (Trainer-type = 2) [set wedex wex
          set wedg wg ]
        set princ (princ + (p-fj * ((.25 * (wg + wex + wedex + wedg) - 1  ) * (alpha ^ t))))]
      set t t + 1
    ]
    if princ >= 0
      [
        set profitable? 1

    ]
  ]
  end
;trainers decide about the quality of training based on their expected profits
to update-quality
  ask companies[
    set alphatraining 0
    let iyears 1
    while [iyears <= TrainingYears]
    [set alphatraining alphatraining + alpha ^ iyears
    set iyears iyears + 1]
    set alphaT 0
    set iyears 1
    while [iyears <= Horizon]
    [set alphaT alphaT + alpha ^ iyears
    set iyears iyears + 1]

    ;set alpha1-3 (alpha + alpha ^ 2 + alpha ^ 3)
  ;  let alpha3-6 (alpha ^ 4 + alpha ^ 5 + alpha ^ 6)
 ;   set alpha6 alphatraining + alpha3-6
    ifelse Trainer-type = 0
    [
      ;;pedtb probaiblity of being educated and stay to be hired min (# hired from trainees and educated (big companies)/ # trainees(big companies))
      ;;pextb probaiblity of being excellent and stay to be hired (# hired from trainees and execellent(big companies)/ # trainees(big companies))
      ;;pgn probaiblity of finding a good in unemployed market min {(average of last three years # unemployed and good/ average of last three years #demand for good) , 1}
      ;;pexn probaiblity of finding an excellent in unemployed market min{ (average of last three years # unemployed and excellent/ average of last three years #demand for excellent),1}
      ;; pedn probaiblity of finding an educated in unemployed market min{ (average of last three years # unemployed and educated/ average of last three years #demand for educated),1}
      ;;cost of training by bigcompanies is twice as much as small ones (for depreciation and so far)
      ;;Pexts, Pedts , Pgts are defined same as pedtb and pextb for small companies
      ifelse mysize = "big"
      [
        ;;; we assumed the reason for training by big c
        set profitg  (( capacity * (traininc - .2 * alphatraining) + (pedextb) * (ProfBEdE - .5 * (wedex + wedg)) * ( alphaT - alphatraining) ) + ((pedgtb )* (ProfBEdG - .5 * (wex + wedg)) * ( alphaT - alphatraining) ) + ((pgtb )* (ProfBNedG - .5 * (1 + wg)) * ( alphaT - alphatraining) ) + ((pextb )* (ProfBNedE - .5 * (wex + wg)) * ( alphaT - alphatraining) ))
       ; The first interpretation about openness
        set decisionlist (list 0 ((- ((wedg + wedex ) / 2) * (alphaT) + (ProfBEdE * 0.5 * (1 - NoPassionsImpactOnSpeed) + ProfBEdG * 0.5 * (1 - NoPassionsImpactOnSpeed)) * (alphaT - alphatraining))) (pgn *( (ProfBNedG - wg) * alphaT + BadTrainingOnSpeed * (ProfBNedE - wex) * ( alphaT - alphatraining)) )(pexn * (ProfBNedE - wex) * alphaT) (pgn * pedn * ((ProfBEdG ) - (wedg + wedex) / 2) * alphaT + ((ProfBEdE - (wedg + wedex) / 2)* BadTrainingOnSpeed) * ( alphaT - alphatraining)  ) (pexn * pedn *(ProfBEdE - wedex ) * alphaT))



        set profitn max decisionlist
        ;;they assume a good skilled agent has the same chance and needs the same time as a rookie to be an excellent one
        ifelse profitg >= profitn [set howtrain? 2
        set hire fput 2 hire
        ][set howtrain? 0
        ifelse ((position profitn decisionlist = 1) or (position profitn decisionlist = 0))
        [set hire fput 0 hire   ]
          [set hire fput 1 hire]]
      ]
      [set profitg  (traininc - alphatraining) + (pedts * pgts * (ProfSEdG - .5 * (wedg + wg)) + pgts * (ProfSNedG - .5 * (1 + wg)) + pedts * pexts * (ProfSEdE - .5 * (wedex + wedg)) + Pexts * (ProfSNedE - .5 * (wg + wex)))* ( alphaT - alphatraining)
        set profitn max (list 0 (pedn * pgn * (ProfSEdG - wedg) * alphaT) (pgn * (ProfSNedg - wg) * alphaT) (pexn *(ProfSNedE - wex) * alphaT) (pedn * pexn *(ProfSEdE - wedex) * alphaT))
        ifelse profitg >= profitn [set howtrain? 2
        set hire fput 2 hire
        ][set howtrain? 0
        ifelse ((position profitn decisionlist = 1) or (position profitn decisionlist = 0))
        [set hire fput 0 hire   ]
          [set hire fput 1 hire]
        ]
      ]


    ]
    ;; howtrained 2 (good) 1 (bad)


    [
      ifelse Trainer-type = 1
      [ set profitg p-hg * prof - costg
        set profitb p-hb * prof
        ifelse profitg >= profitb [set howtrain? 2][set howtrain? 1]
      ]
      [ ;; Trainer-type = 2
        ifelse mysize = "big" [
        set profitg traininc + 1 * alphatraining + wex * alphaT  - p-ovgb  * alphaT
          set profitb traininc + 1 * alphatraining + wex * alphaT  - p-ovbb * alphaT
        set profitn wex * alphaT
        ]
        [
          set profitg traininc + 1 * alphatraining + wg * alphaT - p-ovgs * alphaT
          set profitb traininc + 1 * alphatraining + wg * alphaT - p-ovbs  * alphaT
          set profitn wg * alphaT
        ]
        ifelse profitg >= profitb [ifelse profitg >= profitn [set howtrain? 2][set howtrain? 0]][ifelse profitb >= profitn [set howtrain? 1][set howtrain? 0]]

      ]
    ]
  ]
  if Trainer-type = 0
  [let d count companies with [mysize = "big" and howtrain? = 2]
    ifelse NoUnion
    [
    ]
    [

      ;;revise it if capacity changes
      set d min (list (floor ((NumberOfSmallCompanies - SmallCompaniesCanTrain) / number-of-big-companies) * d ) (count companies with [mysize = "small"]))
      ask n-of d companies with [mysize = "small"][set howtrain? 0
      set hire replace-item 0 hire 1
      ]
  ]
  ]
end
;here skills of the apprentices is upadated based on the quality of training, passion, schools, etc.
to skill-update
  ask apprentices with [tarining-place != "?" and tarining-place != "left" and tarining-place != "lj"][
   let itbe tarining-place

    let speed 1 / TrainingYears
    if passion < .5 [set speed (1 - NoPassionsImpactOnSpeed) * speed]
    if ([howtrain?] of companies with [id = itbe] = 1 or [howtrain?] of companies with [id = itbe] = 0) [set speed (1 - BadTrainingOnSpeed) * speed]
    ifelse school-or-knowledge
    [set s-ed s-ed + speed * talent-ed
      if (([mysize] of companies with [id = itbe] = "small" ) or (Trainer-type = 1)) [set speed (1 - TrainingSpeedReductionForSmallCompanies/Contractors) * speed]
      set s-w s-w + speed * talent-w
    ][
      if (([mysize] of companies with [id = itbe] = "small") or (Trainer-type = 1)) [set speed (1 - TrainingSpeedReductionForSmallCompanies/Contractors) * speed]
      set speed (1 - ImpactOfSchoolOnSkill) * speed
      set s-w s-w + speed * talent-w
      if random-float 1 <= .5 [set s-ed s-ed + speed * talent-ed ]
    ]
    set year-in-apprent year-in-apprent + 1
    set pred-s-ed s-ed
    set pred-s-w s-w
   ; let alphan 0
      set alphatraining 0
    let iyears 1
    while [iyears <= TrainingYears]
    [set alphatraining alphatraining + alpha ^ iyears
    set iyears iyears + 1]

   set alphaT 0
    set iyears 1
    while [iyears <= Horizon]
    [set alphaT alphaT + alpha ^ iyears
    set iyears iyears + 1]

    if year-in-apprent <= TrainingYears - 1  [
      ;;;they predict their progress with some positive attitude
      set pred-s-ed (TrainingYears / (year-in-apprent - LearningSpeedOverEstimation)) * s-ed
      set pred-s-w (TrainingYears / (year-in-apprent - LearningSpeedOverEstimation)) * s-w
      let i TrainingYears - year-in-apprent
      while [i <= Horizon ]
      [
        set alphan alphan + (alpha ^ i)
        set i i + 1
      ]
    ]
    set pred-prof 0
    ifelse Trainer-type < 2[
    ifelse pred-s-ed >= AcademicSkillThreshold
    [
      ifelse pred-s-w >= ExcellentWBSkillThreshold
      [
        if Trainer-type = 0 [

        if (item 0 ([mysize] of companies with [id = itbe])) = "big" [set pred-prof  .5 * (wedg + wedex )]
        if (item 0 ([mysize] of companies with [id = itbe])) = "small" [set pred-prof  .5 * (wg + wex )]
        ]
        set pred-prof alphan * max (list (pfjedex * wedex) (pfjex * wex) (pfjedg * wedg) (pfjg * wg) pred-prof)
      ]
      [
        ifelse pred-s-w >= AdequateWBSkillThreshold
        [set pred-prof  alphan * max (list (pfjedg * wedg) (pfjg * wg))]
        [set pred-prof alphan]
      ]
    ]
    [
      ifelse pred-s-w >= ExcellentWBSkillThreshold
      [if Trainer-type = 0 [

        if (item 0 ([mysize] of companies with [id = itbe])) = "small" [set pred-prof  .5 * (wg + wex )]      ]
        set pred-prof alphan * max (list (pfjex * wex) (pfjg * wg))
      ]
      [
        ifelse pred-s-w >= AdequateWBSkillThreshold
        [set pred-prof  alphan * (pfjg * wg)]
        [set pred-prof alphan]
      ]
    ]
    ifelse (pred-prof < alphaT )
    [
      set tarining-place "left"
    ]
    [
      ifelse s-ed >= AcademicSkillThreshold
      [
        ifelse s-w >= ExcellentWBSkillThreshold[
          if Trainer-type = 0 [
          if (item 0 ([mysize] of companies with [id = itbe])) = "big" [set prof-lj alphaT * .5 * (wedg + wedex )]
            if (item 0 ([mysize] of companies with [id = itbe])) = "small" [set prof-lj alphaT * .5 * (wg + wex )]]
          set prof-lj  max (list (alphaT * pfjedex * wedex) (alphaT * pfjex * wex) (alphaT * pfjedg * wedg) (alphaT * pfjg * wg) prof-lj)
        ]
        [
          if s-w >= AdequateWBSkillThreshold
          [set prof-lj alphaT * max (list (pfjedg * wedg) (pfjg * wg))]
        ]
      ]
      [
        ifelse s-w >= ExcellentWBSkillThreshold
        [if Trainer-type = 0   [
          if (item 0 ([mysize] of companies with [id = itbe])) = "small" [set prof-lj alphaT * .5 * (wg + wex )]]
          set prof-lj  max (list  (alphaT * pfjex * wex)( alphaT * pfjg * wg) prof-lj)
        ]
        [
          if s-w >= AdequateWBSkillThreshold
          [set prof-lj alphaT *  (pfjg * wg)]
        ]
      ]
    ]
      if (pred-prof <= prof-lj and random-float 1 <= check )[
      set tarining-place "lj"
        set wud 0
    ]
    if open? and random-float 1 <= .1  [set tarining-place "left"]
  ]
    [
      ifelse pred-s-w >= ExcellentWBSkillThreshold
      [
        set pred-prof alphan * max (list (pfjex * wex) (pfjg * wg))
      ]
      [
        ifelse pred-s-w >= AdequateWBSkillThreshold
        [set pred-prof  alphan * (pfjg * wg)]
        [set pred-prof alphan]
      ]
      ;they decide to leave the programme
    ifelse (pred-prof < alphaT )
    [
      set tarining-place "left"
    ]
    [
        ifelse s-w >= ExcellentWBSkillThreshold
        [
          set prof-lj  max (list (alphaT * pfjex * wex)  (alphaT * pfjg * wg) prof-lj)
        ]
        [
          if s-w >= AdequateWBSkillThreshold
          [set prof-lj alphaT *  (pfjg * wg)]
        ]
    ]
      ;they decide to look for a job instead of continuing the programme
    if (pred-prof <= prof-lj and random-float 1 <= check )[
      set tarining-place "lj"
        set wud 0
    ]
    ]
  ]
  set no-edex count apprentices with [s-w >= ExcellentWBSkillThreshold  and s-ed >= AcademicSkillThreshold]
  set no-edg count apprentices with [s-w >= AdequateWBSkillThreshold and s-w < ExcellentWBSkillThreshold and s-ed >= AcademicSkillThreshold]
  set no-ex  count apprentices with [s-w >= ExcellentWBSkillThreshold and s-ed < AcademicSkillThreshold]
  set no-g count apprentices with [s-w >= AdequateWBSkillThreshold and s-w < ExcellentWBSkillThreshold and s-ed < AcademicSkillThreshold]
  set no-b count apprentices with [s-w < AdequateWBSkillThreshold and year-in-apprent > 0]
end
;;the companies hire from their own apprentices
to hiring-step
  ask companies
  [
    let idd id
    if Trainer-type = 0 and item 2 hire = 2
    [
      if count apprentices with [tarining-place = idd and year-in-apprent = TrainingYears  and s-w >= AdequateWBSkillThreshold] < 1 [set hire replace-item 2 hire 1]
      ifelse count apprentices with [tarining-place = idd and year-in-apprent = TrainingYears  and s-ed >= AcademicSkillThreshold and s-w >= ExcellentWBSkillThreshold] >= 1
      [
        ifelse mysize = "big"
        [set edexb edexb + 1
          set incb replace-item 3 incb (1 + (item 3 incb))]
        [set edexs edexs + 1
          set incs replace-item 3 incs (1 + (item 3 incs))]
        set need? 0
        ask one-of apprentices with [tarining-place = idd and year-in-apprent = TrainingYears  and s-ed >= AcademicSkillThreshold and s-w >= ExcellentWBSkillThreshold]
        [
          set tarining-place  "hired"
        ]
      ]
      [
        ifelse count apprentices with [tarining-place = idd and year-in-apprent = TrainingYears  and s-ed >= AcademicSkillThreshold and s-w >= AdequateWBSkillThreshold] >= 1
        [set need? 0
          ifelse mysize = "big"
          [set edgb edgb + 1
            set incb replace-item 2 incb (1 + (item 2 incb))]
          [set edgs edgs + 1
            set incs replace-item 2 incs (1 + (item 2 incs))]
          ask one-of apprentices with [tarining-place = idd and year-in-apprent = TrainingYears  and s-ed >= AcademicSkillThreshold and s-w >= AdequateWBSkillThreshold]
          [
            set tarining-place "hired"
          ]
        ]
        [
          ifelse count apprentices with [tarining-place = idd and year-in-apprent = TrainingYears  and s-w >= ExcellentWBSkillThreshold] >= 1
          [
            ifelse mysize = "big"
            [set exb exb + 1
              set incb replace-item 1 incb (1 + (item 1 incb))]
            [set exs exs + 1
            set incs replace-item 1 incs (1 + (item 1 incs))]
            set need? 0
             ask one-of apprentices with [tarining-place = idd and year-in-apprent = TrainingYears  and s-w >= ExcellentWBSkillThreshold]
            [
              set tarining-place "hired"
            ]
          ]
          [if count apprentices with [tarining-place = idd and year-in-apprent = TrainingYears  and s-w >= AdequateWBSkillThreshold] >= 1
            [
             ifelse mysize = "big"
              [set gb gb + 1
              set incb replace-item 0 incb (1 + (item 0 incb))]
              [set gs gs + 1
              set incs replace-item 0 incs (1 + (item 0 incs))]
              set need? 0
              ask one-of apprentices with [tarining-place = idd and year-in-apprent = TrainingYears and s-w >= AdequateWBSkillThreshold]
              [
                set tarining-place  "hired"
              ]
            ]
          ]
        ]
      ]
    ]
    ask apprentices with [tarining-place = idd and year-in-apprent = TrainingYears]
      [
        set tarining-place "lj"

        set wud 0
      ]
  ]

    set n-finished count apprentices with [(year-in-apprent = TrainingYears) and (tarining-place = "lj")]
end
;;the function for updating the demand given demand of big companies
to update-big [setin]

    ifelse db >= (item setin dummy-supply)
    [
      set demand replace-item setin demand (item setin demand + db)
      set incb replace-item setin incb ((item setin dummy-supply) + (item setin incb))
      set db db - (item setin dummy-supply)

      set dummy-supply replace-item setin dummy-supply 0
  ]
  [set dummy-supply replace-item setin dummy-supply ((item setin dummy-supply) - db)
    set demand replace-item setin demand (item setin demand + db)
    set incb replace-item setin incb (db + (item setin incb))
    set db 0
  ]
  set lb replace-item setin lb 0
end
;;the function for updating the demand given demand of small companies
to update-small [seti]
    ifelse ds >= (item seti dummy-supply)
      [
        set demand replace-item seti demand (item seti demand + ds)
        set ds ds - (item seti dummy-supply)
      set incs replace-item seti incs ((item seti dummy-supply) + (item seti incs))
      set dummy-supply replace-item seti dummy-supply 0
      ]
      [set dummy-supply replace-item seti dummy-supply ((item seti dummy-supply) - ds)
    set demand replace-item seti demand (item seti demand + ds)
    set incs replace-item seti incs (ds + (item seti incs))
    set ds 0
      ]
  set ls replace-item seti ls 0
end
;;the companies hire from the labour market/other societies
to hiring
  ifelse Trainer-type = 0
  [
    ask companies [set need? 0]
    ask companies with [(item 2 hire) = 1][set need? 1]
    set demand (list 0 0 0 0)
    let nedex count apprentices with [(s-ed >= AcademicSkillThreshold) and (s-w >= ExcellentWBSkillThreshold) and (tarining-place = "lj")]
    let nedg count apprentices  with [(s-ed >= AcademicSkillThreshold) and (s-w >= AdequateWBSkillThreshold) and (s-w < ExcellentWBSkillThreshold) and (tarining-place = "lj")]
    let nex count apprentices  with [(s-ed < AcademicSkillThreshold) and (s-w >= ExcellentWBSkillThreshold) and (tarining-place = "lj")]
    let ng count apprentices  with [(s-ed < AcademicSkillThreshold) and (s-w < ExcellentWBSkillThreshold) and (s-w >= AdequateWBSkillThreshold) and (tarining-place = "lj")]
    ;
    set supw (list ng nex nedg nedex)
    set dummy-supply supw
    set db count companies with [need? = 1 and mysize = "big"]
    set ds count companies with [need? = 1 and mysize = "small"]
    set lb (list (profBNedG - wg) (profBNedE - wex) (profBEdG - wedg) (profBEdE - wedex) )
    set ls (list (profSNedG - wg) (profSNedE - wex) (profSEdG - wedg) (profSEdE - wedex) )
    let ind 0
    while [ind <= 3 and db > 0]
    [
      ifelse (max lb) > 0
      [let this position (max lb) lb
        update-big this
      ]
      [set ind 4]
      set ind ind + 1
    ]
    set ind 0
    while [ind <= 3 and ds > 0]
    [
      ifelse (max ls) > 0
      [let thiss position (max ls) ls
        update-small thiss
      ]
      [set ind 4]
      set ind ind + 1
    ]
    let nb count companies with [(item 2 hire) = 2 and (mysize = "big")]
    let ns count companies with [(item 2 hire) = 2 and (mysize = "small")]
    if nb > 0 [
      set pedextb .5 * pedextb + .5 *(min (list 1 ((edexb) / nb )))
      set pedgtb .5 * pedgtb + .5 *(min (list 1 ((edgb) / nb )))
      set pextb .5 * pextb + .5 *(min (list 1 ((exb) / nb )))
      set pgtb .5 * pgtb + .5 * (min (list 1 ((gb ) / nb) ))]

    if ns > 0[
      set pedts .5 * pedts + .5 * ((edexs + edgs) / ns)
      set pexts .5 * pexts + .5 * ((edexs + exs) / ns)
      set pgts .5 * pgts + .5 * ((edgs + gs) / ns)]
    ifelse (item 3 demand)+(item 2 demand) > 0
    [set pedn .5 * pedn + .5 * (min (list 1 ((nedex + nedg) / ((item 3 demand)+(item 2 demand)) )))]
    ;[if (nedex + nedg) > 0 [set pedn .5 * pedn + .5 * random-float 1 * (nedex + nedg / 60)] ]
      [ifelse (nedex + nedg) > 0 [set pedn .5 * pedn + .5 * random-float 1]; * (nedex + nedg / 60)] ]
    [set pedn .5 * pedn    ]]
    ifelse (item 0 demand) + (item 2 demand)> 0
    [set pgn .5 * pgn + .5 * (min (list 1 ((ng + nedg) / ((item 0 demand) + (item 2 demand)) )))]
    ;[if (ng + nedg) > 0 [set pgn .5 * pgn + .5 * random-float 1 * (ng + nedg / 80)] ]
      [ifelse (ng + nedg) > 0 [set pgn .5 * pgn + .5 * random-float 1]; * (ng + nedg / 80)] ]
      [set pgn .5 * pgn]]
    ifelse (item 1 demand) + (item 3 demand)> 0
    [set pexn .5 * pexn + .5 * (min (list 1 ((nex + nedex) / ((item 1 demand) + (item 3 demand)) )))]
   ; [if (nex + nedex) > 0 [set pexn .5 * pexn + .5 * random-float 1 * (nex + nedex / 40)] ]
    [ifelse (nex + nedex) > 0 [set pexn .5 * pexn + .5 * random-float 1 ];* (nex + nedex / 40)] ]
      [set pexn .5 * pexn + .5]]

    ifelse ng > 0 [set pfjg (1 - TraineesCurrentInformationWeight) * pfjg + TraineesCurrentInformationWeight * ( min list 1 ((item 0 demand) / ng))]
    [if (item 0 demand) > 0 [set pfjg (1 - TraineesCurrentInformationWeight) * pfjg + TraineesCurrentInformationWeight * (.5 + random-float .5) ]]
    ifelse nex > 0 [set pfjex (1 - TraineesCurrentInformationWeight) * pfjex + TraineesCurrentInformationWeight * (min list 1 ((item 1 demand) / nex))]
    [if (item 1 demand) > 0 [set pfjex (1 - TraineesCurrentInformationWeight) * pfjex + TraineesCurrentInformationWeight * (.5 + random-float .5)]]
    ifelse nedg > 0 [set pfjedg (1 - TraineesCurrentInformationWeight) * pfjedg + TraineesCurrentInformationWeight * (min list 1 ((item 2 demand) / nedg))]
    [if (item 2 demand) > 0 [set pfjedg (1 - TraineesCurrentInformationWeight) * pfjedg + TraineesCurrentInformationWeight * (.5 + random-float .5)]]
    ifelse nedex > 0 [set pfjedex (1 - TraineesCurrentInformationWeight) * pfjedex + TraineesCurrentInformationWeight * (min list 1 ((item 3 demand) / nedex))]
    [if (item 3 demand) > 0 [set pfjedex (1 - TraineesCurrentInformationWeight) * pfjedex + TraineesCurrentInformationWeight * (.5 + random-float .5)]]
    ifelse (edexb + edexs + edgb + edgs + exb + exs + gs + gb + nex + ng + nedg + nedex) = 0
    [set p-fj random-float 1]
    [ set p-fj (edexb + edexs + edgb + edgs + exb + exs + gs + gb + (pfjedex * nedex) + (pfjex * nex) + (pfjg * ng) + (pfjedg * nedg) )  / (edexb + edexs + edgb + edgs + exb + exs + gs + gb + nex + ng + nedg + nedex)]

    if item 0 dummy-supply < item 0 supw
    [let ndie (item 0 supw) - (item 0 dummy-supply)
      ;set no-g no-g + ndie
      ask n-of ndie apprentices with [(s-ed < AcademicSkillThreshold) and (s-w < ExcellentWBSkillThreshold) and (s-w >= AdequateWBSkillThreshold) and (tarining-place = "lj")] [die]
    ]
      if (item 0 dummy-supply > WagesStickinessThreshold and ticks > TrainingYears ) [set wg max (list (wg - 1 ) 2)]

    if item 1 dummy-supply < item 1 supw
    [let ndie (item 1 supw) - (item 1 dummy-supply)
     ; set no-ex no-ex + ndie
      ask n-of ndie apprentices with [(s-ed < AcademicSkillThreshold) and (s-w >= ExcellentWBSkillThreshold) and (tarining-place = "lj")] [die] ]

      if (item 1 dummy-supply > WagesStickinessThreshold and ticks > TrainingYears ) [set wex max (list (wg + 1 ) (wex - 1))]

    if item 2 dummy-supply < item 2 supw
    [let ndie (item 2 supw) - (item 2 dummy-supply)
      ;  set no-edg no-edg + ndie
      ask n-of ndie apprentices with [(s-ed >= AcademicSkillThreshold) and (s-w >= AdequateWBSkillThreshold) and (s-w < ExcellentWBSkillThreshold) and (tarining-place = "lj")] [die] ]
    if (item 2 dummy-supply > WagesStickinessThreshold and ticks > TrainingYears ) [set wedg max (list (wedg - 1 ) (wex + 1))]
    if item 3 dummy-supply < item 3 supw
    [      let ndie (item 3 supw) - (item 3 dummy-supply)
      ;    set no-edexb no-edexb + ndie
      ask n-of ndie apprentices with [(s-ed >= AcademicSkillThreshold) and (s-w >= ExcellentWBSkillThreshold) and (tarining-place = "lj")] [die] ]
    if (item 3 dummy-supply > WagesStickinessThreshold and ticks > TrainingYears )[set wedex max (list (wedex - 1 ) (wedg + 1))]
    if ((item 3 demand) > WagesStickinessThreshold + (item 3 supw) and ticks > TrainingYears )[set wedex min (list (wedex + 1 ) (profBEdE - 1) (profSEdE - 1) )]
    if ((item 2 demand) > WagesStickinessThreshold + (item 2 supw) and ticks > TrainingYears )[set wedg min (list (wedg + 1 ) (profBEdG - 1) (profSEdG - 1) (wedex - 1))]
    if ((item 1 demand) > WagesStickinessThreshold + (item 1 supw) and ticks > TrainingYears )[set wex min (list (wedg - 1 ) (profBNedE - 1) (profSNedE - 1) (wex + 1))]
    if ((item 0 demand) > WagesStickinessThreshold + (item 0 supw) and ticks > TrainingYears )[set wg min (list (wex - 1 ) (profBNedG - 1) (profSNedG - 1) (wg + 1))]
    ask companies[
      set hire remove-item 3 hire]
  ]
  [
    ifelse Trainer-type = 1
    [

      let nedex count apprentices with [(s-ed >= AcademicSkillThreshold) and (s-w >= ExcellentWBSkillThreshold) and (tarining-place = "lj")]
      let nedg count apprentices  with [(s-ed >= AcademicSkillThreshold) and (s-w >= AdequateWBSkillThreshold) and (s-w < ExcellentWBSkillThreshold) and (tarining-place = "lj")]
      let nex count apprentices  with [(s-ed < AcademicSkillThreshold) and (s-w >= ExcellentWBSkillThreshold) and (tarining-place = "lj")]
      let ng count apprentices  with [(s-ed < AcademicSkillThreshold) and (s-w < ExcellentWBSkillThreshold) and (s-w >= AdequateWBSkillThreshold) and (tarining-place = "lj")]
      set supw (list ng nex nedg nedex)
      set dummy-supply supw
      set demand (list 0 0 0 0)
      set db ceiling ( number-of-big-companies)
      set ds 4 * number-of-big-companies
      set lb (list (profBNedG - wg) (profBNedE - wex) (profBEdG - wedg) (profBEdE - wedex) )
      set ls (list (profSNedG - wg) (profSNedE - wex) (profSEdG - wedg) (profSEdE - wedex) )

      ;;revise it here
      let iydu 1
      let alphahT 0
      while [iydu <= Horizon]
    [set alphahT alphahT + alphaMu ^ iydu
    set iydu iydu + 1]
      set iydu TrainingYears + 1
      let alphahTra 0
      while [iydu <= Horizon ]
    [set alphahTra alphahTra + alphaMu ^ iydu
    set iydu iydu + 1]


  ;    let alphah1-3 (alphaMu + alphaMu ^ 2 + alphaMu ^ 3)
 ;     let alphah3-6 (alphaMu ^ 4 + alphaMu ^ 5 + alphaMu ^ 6)
  ;    let alphah6 alphah1-3 + alphah3-6
;;; note that when model considers contractors we assume that all companies have the same discount factors which are equal to the average of alpha
let outhire 0
    ifelse Influx[

        ;;the second interpretation of openness (i.e. cheaper workforce)
       set outhire ((- ((wedg + wedex + wex ) / 3) * (alphahT) + (profBEdE * .5 + profBEdG * .5) * (alphahT ))) ;;rvise this
      ][
        ;;; The first interpretation about openness
        set outhire ((- ((wedg + wedex ) / 2) * (alphahT) + (profBEdE * .5 * (1 - NoPassionsImpactOnSpeed ) + profBEdG * .5 * (1 - NoPassionsImpactOnSpeed )) * (alphahT - alphahTra))) ;;rvise this
      ]

      let ind 0
      while [ind <= 3 and db > 0]
      [
        ifelse (max lb) > outhire
        [let this position (max lb) lb
          update-big this
        ]
        [set ind 4]
        set ind ind + 1
      ]

      set ind 0
      while [ind <= 3 and ds > 0]
      [
        ifelse (max ls) > 0
        [let thiss position (max ls) ls
          update-small thiss
        ]
        [set ind 4]
        set ind ind + 1
      ]

      ifelse ng > 0 [set pfjg (1 - TraineesCurrentInformationWeight) * pfjg + TraineesCurrentInformationWeight * ( min (list 1 ((item 0 demand) / ng)))]
      [if (item 0 demand) > 0 [set pfjg (1 - TraineesCurrentInformationWeight) * pfjg + TraineesCurrentInformationWeight * (.5 + random-float .5)]]
      ifelse nex > 0 [set pfjex (1 - TraineesCurrentInformationWeight) * pfjex + TraineesCurrentInformationWeight * (min (list 1 ((item 1 demand) / nex)))]
      [if (item 1 demand) > 0 [set pfjex (1 - TraineesCurrentInformationWeight) * pfjex + TraineesCurrentInformationWeight * (.5 + random-float .5)]]
      ifelse nedg > 0 [set pfjedg (1 - TraineesCurrentInformationWeight) * pfjedg + TraineesCurrentInformationWeight * (min (list 1 ((item 2 demand) / nedg)))]
      [if (item 2 demand) > 0 [set pfjedg (1 - TraineesCurrentInformationWeight) * pfjedg + TraineesCurrentInformationWeight * (.5 + random-float .5)]]
      ifelse nedex > 0 [set pfjedex (1 - TraineesCurrentInformationWeight) * pfjedex + TraineesCurrentInformationWeight * (min ((list 1 ((item 3 demand) / nedex))))]
      [if (item 3 demand) > 0 [set pfjedex (1 - TraineesCurrentInformationWeight) * pfjedex + TraineesCurrentInformationWeight * (.5 + random-float .5)]]
      ifelse (edexb + edexs + edgb + edgs + exb + exs + gs + gb + nex + ng + nedg + nedex) = 0
      [set p-fj random-float 1]
      [ set p-fj (edexb + edexs + edgb + edgs + exb + exs + gs + gb + (pfjedex * nedex) + (pfjex * nex) + (pfjg * ng) + (pfjedg * nedg) )  / (edexb + edexs + edgb + edgs + exb + exs + gs + gb + nex + ng + nedg + nedex)]
      if item 0 dummy-supply < item 0 supw
      [let ndie (item 0 supw) - (item 0 dummy-supply)
        ask n-of ndie apprentices with [(s-ed < AcademicSkillThreshold) and (s-w < ExcellentWBSkillThreshold) and (s-w >= AdequateWBSkillThreshold) and (tarining-place = "lj")] [die]     ]

      if (item 0 dummy-supply > WagesStickinessThreshold and ticks > TrainingYears )[set wg max (list (wg - 1 ) 2)]

      if item 1 dummy-supply < item 1 supw
      [let ndie (item 1 supw) - (item 1 dummy-supply)
        ask n-of ndie apprentices with [(s-ed < AcademicSkillThreshold) and (s-w >= ExcellentWBSkillThreshold) and (tarining-place = "lj")] [die] ]

        if (item 1 dummy-supply > WagesStickinessThreshold and ticks > TrainingYears )[set wex max (list (wg + 1 ) (wex - 1))]

      if item 2 dummy-supply < item 2 supw
      [let ndie (item 2 supw) - (item 2 dummy-supply)
        ask n-of ndie apprentices with [(s-ed >= AcademicSkillThreshold) and (s-w >= AdequateWBSkillThreshold) and (s-w < ExcellentWBSkillThreshold) and (tarining-place = "lj")] [die] ]
      if (item 2 dummy-supply > WagesStickinessThreshold and ticks > TrainingYears )[set wedg max (list (wedg - 1 ) (wex + 1))]
      if item 3 dummy-supply < item 3 supw
      [
        let ndie (item 3 supw) - (item 3 dummy-supply)
        ask n-of ndie apprentices with [(s-ed >= AcademicSkillThreshold) and (s-w >= ExcellentWBSkillThreshold) and (tarining-place = "lj")] [die] ]
      if (item 3 dummy-supply > WagesStickinessThreshold and ticks > TrainingYears )[set wedex max (list (wedex - 1 ) (wedg + 1))]
      if ((item 3 demand) > WagesStickinessThreshold + (item 3 supw) and ticks > TrainingYears)[set wedex min (list (wedex + 1 ) (profBEdE - 1) (profSEdE - 1))]
      if ((item 2 demand) > WagesStickinessThreshold + (item 2 supw) and ticks > TrainingYears)[set wedg min (list (wedg + 1 ) (profBEdG - 1) (profSEdG - 1)  (wedex - 1))]
      if ((item 1 demand) > WagesStickinessThreshold + (item 1 supw) and ticks > TrainingYears)[set wex min (list (wedg - 1 ) (profBNedE - 1) (profSNedE - 1) (wex + 1))]
      if ((item 0 demand) > WagesStickinessThreshold + (item 0 supw) and ticks > TrainingYears)[set wg min (list (wex - 1 ) (profBNedG - 1) (profSNedG - 1) (wg + 1))]
   if (count companies with [howtrain? = 2] > 0)
      [
        let aaa count companies with [howtrain? = 2]
        let bbb count companies with [howtrain? = 1]
        let dummyprob1  (db + ds) / (count apprentices with [tarining-place = "lj"] + db + ds )
      set p-hg (1 - TrainersCurrentInformationWeight)  * p-hg + TrainersCurrentInformationWeight * dummyprob1 / (aaa + (1 - BadTrainingOnSpeed) *  bbb)
      set p-hb (1 - TrainersCurrentInformationWeight ) * p-hb + TrainersCurrentInformationWeight   * dummyprob1 / (bbb + (1 - BadTrainingOnSpeed) *  bbb)
      ]
    ]
    [;;trainer type = 2 (craft)
      let nex count apprentices with [(s-w >= ExcellentWBSkillThreshold) and (tarining-place = "lj")]

      let ng count apprentices  with [(s-w >= AdequateWBSkillThreshold) and (s-w < ExcellentWBSkillThreshold) and (tarining-place = "lj")]
      set supw (list ng nex)
      set dummy-supply supw
      set demand (list 0 0)
      set db ceiling ( demandrate * (number-of-big-companies))
      set ds ceiling (demandrate * NumberOfSmallCompanies )
      set lb (list (profBG - wg) (profBE - wex) )
      set ls (list  (profSG - wg) (profSE - wex))
      let ind 0
      while [ind <= 1 and db > 0]
      [
        ifelse (max lb) > 0
        [let this position (max lb) lb
          update-big this
        ]
        [set ind 4]
        set ind ind + 1
      ]
      set ind 0
      while [ind <= 1 and ds > 0]
      [
        ifelse (max ls) > 0
        [let thiss position (max ls) ls
          update-small thiss
        ]
        [set ind 4]
        set ind ind + 1
      ]
      ifelse Guild-restrictions?[
        ;; the system is in favour of insiders when there is an overflow
        if ((item 1 demand) > ArtisanWagesStickinessThreshold + (item 1 supw) and ticks > TrainingYears)[set wex min (list  profBE profSE (wex + 1))]
        if ((item 0 demand) > ArtisanWagesStickinessThreshold + (item 0 supw) and ticks > TrainingYears)[set wg min (list (wex - 1 ) profBG profSG (wg + 1))]
        ifelse (item 0 dummy-supply) > 0
        [ ifelse ng > 0 [set pfjg (1 - TraineesCurrentInformationWeight) * pfjg + TraineesCurrentInformationWeight * ( min list 1 ((item 0 demand) / ng))]
          [if (item 0 demand) > 0 [set pfjg (1 - TraineesCurrentInformationWeight) * pfjg + TraineesCurrentInformationWeight * (.5 + random-float .5)]]
        ]
        [ ifelse ng > 0 [set pfjg (1 - TraineesCurrentInformationWeight) * pfjg + TraineesCurrentInformationWeight * ( min list 1 ((item 0 demand) / ng))]
          [if (item 0 demand) > 0 [set pfjg (1 - TraineesCurrentInformationWeight) * pfjg + TraineesCurrentInformationWeight * (.5 + random-float .5)]]
        ]
        ifelse (item 1 dummy-supply) > 0
        [ifelse nex > 0 [set pfjex (1 - TraineesCurrentInformationWeight) * pfjex + TraineesCurrentInformationWeight * (min list 1 ((item 1 demand) / nex))]
          [if (item 1 demand) > 0 [set pfjex (1 - TraineesCurrentInformationWeight) * pfjex + TraineesCurrentInformationWeight * (.5 + random-float .5)]]
        ]
        [ifelse nex > 0 [set pfjex (1 - TraineesCurrentInformationWeight) * pfjex + TraineesCurrentInformationWeight * (min list 1 ((item 1 demand) / nex))]
          [if (item 1 demand) > 0 [set pfjex (1 - TraineesCurrentInformationWeight) * pfjex + TraineesCurrentInformationWeight * (.5 + random-float .5)]]
        ]
        if item 0 dummy-supply < item 0 supw
        [let ndie (item 0 supw) - (item 0 dummy-supply)
          ask n-of ndie apprentices with [ (s-w < ExcellentWBSkillThreshold) and (s-w >= AdequateWBSkillThreshold) and (tarining-place = "lj")] [die]     ]
        if item 1 dummy-supply < item 1 supw
        [let ndie (item 1 supw) - (item 1 dummy-supply)
          ask n-of ndie apprentices with [(s-w >= ExcellentWBSkillThreshold) and (tarining-place = "lj")] [die] ]
        set p-ovgb 0
        set p-ovbb 0
        set p-ovgs 0
        set p-ovbs 0
      ]
      [
        ifelse ng > 0 [set pfjg (1 - TraineesCurrentInformationWeight) * pfjg + TraineesCurrentInformationWeight * ( min list 1 ((item 0 demand) / ng))]
        [if (item 0 demand) > 0 [set pfjg (1 - TraineesCurrentInformationWeight) * pfjg + TraineesCurrentInformationWeight * (.5 + random-float .5)]]
        ifelse nex > 0 [set pfjex (1 - TraineesCurrentInformationWeight) * pfjex + TraineesCurrentInformationWeight * (min list 1 ((item 1 demand) / nex))]
        [if (item 1 demand) > 0 [set pfjex (1 - TraineesCurrentInformationWeight) * pfjex + TraineesCurrentInformationWeight * (.5 + random-float .5)]]
        if item 0 dummy-supply < item 0 supw
        [let ndie (item 0 supw) - (item 0 dummy-supply)
          ask n-of ndie apprentices with [ (s-w < ExcellentWBSkillThreshold) and (s-w >= AdequateWBSkillThreshold) and (tarining-place = "lj")] [die]     ]
          if (item 0 dummy-supply > ArtisanWagesStickinessThreshold and ticks > TrainingYears)[set wg max (list (wg - 1 ) 2)]

    if item 1 dummy-supply < item 1 supw
    [let ndie (item 1 supw) - (item 1 dummy-supply)
      ask n-of ndie apprentices with [(s-w >= ExcellentWBSkillThreshold) and (tarining-place = "lj")] [die] ]

      if (item 1 dummy-supply > ArtisanWagesStickinessThreshold and ticks > TrainingYears)[set wex max (list (wg + 1 ) (wex - 1))]

    if ((item 1 demand) > ArtisanWagesStickinessThreshold + (item 1 supw) and ticks > TrainingYears)[set wex min (list  profBE profSE (wex + 1))]
    if ((item 0 demand) > ArtisanWagesStickinessThreshold + (item 0 supw) and ticks > TrainingYears)[set wg min (list (wex - 1 ) profBG profSG (wg + 1))]
    if (count companies with [howtrain? > 0]) > 0[
     if (count companies with [howtrain? = 2] > 0)
      [
        let aaa count companies with [howtrain? = 2]
        let bbb count companies with [howtrain? = 1]
        let dummyprob1  (db + ds) / (count apprentices with [tarining-place = "lj"] + db + ds )
      set p-hg (1 - TrainersCurrentInformationWeight)  * p-hg + TrainersCurrentInformationWeight * dummyprob1 / (aaa + (1 - BadTrainingOnSpeed) *  bbb)
      set p-hb (1 - TrainersCurrentInformationWeight ) * p-hb + TrainersCurrentInformationWeight   * dummyprob1 / (aaa + (1 -  BadTrainingOnSpeed) *  bbb)
      ]

        ]
    let p1 0
    let p2 0
    if (item 1 dummy-supply > 0 and db > 0)[ set p1 min (list 1 ((item 1 dummy-supply) / db)) ]
    if (item 0 dummy-supply > 0 and ds > 0)[ set p2 min (list 1 ((item 0 dummy-supply) / ds)) ]
    set p-ovgb (1 - TrainersCurrentInformationWeight) * p-ovgb + TrainersCurrentInformationWeight * p1
    set p-ovbb (1 - TrainersCurrentInformationWeight) * p-ovbb + TrainersCurrentInformationWeight * .9 * p1
    set p-ovgs (1 - TrainersCurrentInformationWeight) * p-ovgs + TrainersCurrentInformationWeight * p2
    set p-ovbs (1 - TrainersCurrentInformationWeight) * p-ovbs + TrainersCurrentInformationWeight * .9 * p2
  ]
  set p-fj min (list 1 (pfjex + pfjg))
]
]
end
;;societal profits gained for training apprentices
to update-profits
ifelse Trainer-type < 2
  [set pred-sys-profit (item 0 incb) * ProfBNedG
    set pred-sys-profit pred-sys-profit + (item 1 incb) * ProfBNedE
    set pred-sys-profit pred-sys-profit + (item 2 incb) * ProfBEdG
    set pred-sys-profit pred-sys-profit + (item 3 incb) * ProfBEdE
    set pred-sys-profit pred-sys-profit + (item 0 incs) * ProfSNedG
    set pred-sys-profit pred-sys-profit + (item 1 incs) * ProfSNedE
    set pred-sys-profit pred-sys-profit + (item 2 incs) * ProfSEdG
    set pred-sys-profit pred-sys-profit + (item 3 incs) * ProfSEdE
  ]
  [set pred-sys-profit (item 0 incb) * ProfBG
    set pred-sys-profit pred-sys-profit + (item 1 incb) * ProfBE
    set pred-sys-profit pred-sys-profit + (item 0 incs) * ProfSG
    set pred-sys-profit pred-sys-profit + (item 1 incs) * ProfSE
  ]
end
;;updating parameters also setting iteration related variables to zero
to update-all
  ask apprentices
  [if open? and random-float 1 <= .1  [set tarining-place "left"]
  ]
  ;inja
  if ticks < TrainingYears
  [
   ifelse Trainer-type < 2[ set wedex Iwedex
    set wedg Iwedad
  set wg  Iwnedad
    set wex Iwnedex]
  [
   set wg Iwad
   set wex  Iwex
  ]



  ]
  set edexb 0
  set edexs 0
  set edgb 0
  set edgs 0
  set exb 0
  set exs 0
  set ds 0
  set db 0
  set gb 0
  set gs 0
  set lb (list 0 0 0 0)
  set ls (list 0 0 0 0)
  set supw (list 0 0 0 0)
  set demand (list 0 0 0 0)
  set dummy-supply (list 0 0 0 0)
    ask companies [set need? 1]

  set n-finished n-finished + count apprentices with [tarining-place = "hired"]
  set n-attend fput  (count apprentices with [year-in-apprent = 1]) n-attend
  ask apprentices with [year-in-apprent = TrainingYears] [set year-in-apprent TrainingYears + 1]
  if ticks >= 2 and (item 2 n-attend) > 0
  [ set per-success (n-finished / (item 2 n-attend))]
  set n-attend remove-item 3 n-attend
  ask apprentices with [tarining-place = "lj"] [set wud wud + 1]
  ask apprentices with [(tarining-place = "lj") and (wud >= 1)] [if (random-float 1 <= ((1 / TraineesMaxWaitingYears) * wud)) [die]]
  ask apprentices with [tarining-place = "hired"][die]
  ask apprentices with [tarining-place = "left"] [die]
  ask apprentices with [((aafordable? = 0) or (profitable? = 1)) and (tarining-place = "?")][die]
  set incb (list 0 0 0 0)
  set incs (list 0 0 0 0)
end
@#$#@#$#@
GRAPHICS-WINDOW
314
10
595
292
-1
-1
13.0
1
10
1
1
1
0
1
1
1
-10
10
-10
10
0
0
1
ticks
30.0

SLIDER
638
347
828
380
number-of-big-companies
number-of-big-companies
5
20
20.0
5
1
NIL
HORIZONTAL

SLIDER
450
533
637
566
NumberOfSmallCompanies
NumberOfSmallCompanies
0
80
80.0
5
1
NIL
HORIZONTAL

SWITCH
115
442
285
475
school-or-knowledge
school-or-knowledge
0
1
-1000

BUTTON
101
30
164
63
NIL
setup
NIL
1
T
OBSERVER
NIL
S
NIL
NIL
1

BUTTON
6
31
69
64
NIL
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
556
298
772
331
LearningSpeedOverEstimation
LearningSpeedOverEstimation
0
1
0.1
0.1
1
NIL
HORIZONTAL

SLIDER
176
339
419
372
TraineesCurrentInformationWeight
TraineesCurrentInformationWeight
0
1
0.7
0.1
1
NIL
HORIZONTAL

SLIDER
3
479
362
512
TrainingSpeedReductionForSmallCompanies/Contractors
TrainingSpeedReductionForSmallCompanies/Contractors
0
1
0.15
0.05
1
NIL
HORIZONTAL

SLIDER
331
421
572
454
TrainersCurrentInformationWeight
TrainersCurrentInformationWeight
0
1
0.5
0.1
1
NIL
HORIZONTAL

SLIDER
426
379
627
412
NoPassionsImpactOnSpeed
NoPassionsImpactOnSpeed
0
1
0.1
.1
1
NIL
HORIZONTAL

SLIDER
380
483
567
516
SmallCompaniesCanTrain
SmallCompaniesCanTrain
0
6
6.0
1
1
NIL
HORIZONTAL

SLIDER
387
576
581
609
AdequateWBSkillThreshold
AdequateWBSkillThreshold
0
1
0.5
.1
1
NIL
HORIZONTAL

SLIDER
630
381
803
414
ImpactOfSchoolOnSkill
ImpactOfSchoolOnSkill
0
1
0.1
.1
1
NIL
HORIZONTAL

SLIDER
233
377
405
410
BadTrainingOnSpeed
BadTrainingOnSpeed
0
1
0.1
.1
1
NIL
HORIZONTAL

SLIDER
1
529
196
562
WagesStickinessThreshold
WagesStickinessThreshold
0
100
30.0
15
1
NIL
HORIZONTAL

SWITCH
113
403
216
436
NoUnion
NoUnion
1
1
-1000

SWITCH
0
442
103
475
Influx
Influx
1
1
-1000

SWITCH
186
301
340
334
Guild-restrictions?
Guild-restrictions?
1
1
-1000

SWITCH
0
407
103
440
Open?
Open?
1
1
-1000

SLIDER
364
297
536
330
Check
Check
0
1
0.2
.1
1
NIL
HORIZONTAL

SLIDER
650
11
822
44
Trainer-type
Trainer-type
0
2
2.0
1
1
NIL
HORIZONTAL

SLIDER
441
340
634
373
TraineesMaxWaitingYears
TraineesMaxWaitingYears
1
10
2.0
1
1
NIL
HORIZONTAL

SWITCH
0
362
123
395
prepayment
prepayment
1
1
-1000

SLIDER
200
529
434
562
ArtisanWagesStickinessThreshold
ArtisanWagesStickinessThreshold
0
54
18.0
9
1
NIL
HORIZONTAL

SLIDER
183
575
375
608
ExcellentWBSkillThreshold
ExcellentWBSkillThreshold
0
1
0.75
0.05
1
NIL
HORIZONTAL

SLIDER
0
576
175
609
AcademicSkillThreshold
AcademicSkillThreshold
0
1
0.5
0.05
1
NIL
HORIZONTAL

SLIDER
0
79
209
112
NumberOfPotentialTrainees
NumberOfPotentialTrainees
0
2000
1700.0
50
1
NIL
HORIZONTAL

SLIDER
579
421
764
454
ShareOfWealthyFamilies
ShareOfWealthyFamilies
0
1
0.2
.1
1
NIL
HORIZONTAL

SLIDER
652
94
824
127
ProfBG
ProfBG
1
100
10.0
1
1
NIL
HORIZONTAL

SLIDER
653
134
825
167
ProfBE
ProfBE
1
100
20.0
1
1
NIL
HORIZONTAL

SLIDER
654
171
826
204
ProfSE
ProfSE
1
50
13.0
1
1
NIL
HORIZONTAL

SLIDER
654
209
826
242
ProfSG
ProfSG
1
100
14.5
.5
1
NIL
HORIZONTAL

SLIDER
3
156
175
189
IWAd
IWAd
1
100
3.0
1
1
NIL
HORIZONTAL

SLIDER
4
195
176
228
IWEdEx
IWEdEx
1
100
10.0
1
1
NIL
HORIZONTAL

SLIDER
3
234
175
267
IWEdAd
IWEdAd
1
100
9.0
1
1
NIL
HORIZONTAL

SLIDER
2
272
174
305
IWEx
IWEx
1
100
11.0
1
1
NIL
HORIZONTAL

SLIDER
1
319
173
352
IWNEdAd
IWNEdAd
1
100
3.0
1
1
NIL
HORIZONTAL

SLIDER
1
119
173
152
IWNEdEx
IWNEdEx
1
100
4.0
1
1
NIL
HORIZONTAL

SLIDER
651
50
823
83
ProfSEdE
ProfSEdE
1
100
14.0
1
1
NIL
HORIZONTAL

SLIDER
652
247
824
280
ProfSEdG
ProfSEdG
1
100
12.0
1
1
NIL
HORIZONTAL

SLIDER
639
537
811
570
ProfSNedE
ProfSNedE
1
100
12.0
1
1
NIL
HORIZONTAL

SLIDER
781
312
953
345
ProfSNedG
ProfSNedG
1
100
10.0
1
1
NIL
HORIZONTAL

SLIDER
836
347
1008
380
ProfBEdE
ProfBEdE
1
100
30.0
1
1
NIL
HORIZONTAL

SLIDER
855
391
1027
424
ProfBEdG
ProfBEdG
1
100
15.0
1
1
NIL
HORIZONTAL

SLIDER
781
425
953
458
ProfBNedE
ProfBNedE
1
100
10.0
1
1
NIL
HORIZONTAL

SLIDER
753
486
925
519
ProfBNedG
ProfBNedG
1
100
5.0
1
1
NIL
HORIZONTAL

SLIDER
835
536
1007
569
alphaMu
alphaMu
0
1
0.9
.1
1
NIL
HORIZONTAL

PLOT
848
10
1048
160
Small Companies/Contractors Who Train
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -15973838 true "" "plot count companies with [mysize = \"small\" and howtrain? = 2]"
"pen-1" 1.0 0 -10022847 true "" "plot count companies with [mysize = \"small\" and howtrain? = 1]"

PLOT
1279
10
1479
160
Number Of Unemployed Agents Given Their Work-Based Skilled
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -15637942 true "" "plot count apprentices with [(s-w >= .75) and (tarining-place = \"lj\")]"
"pen-1" 1.0 0 -8990512 true "" "plot count apprentices  with [(s-w >= .5) and (s-w < .75) and (tarining-place = \"lj\")]"

PLOT
1057
167
1257
317
Predicted GDI
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -11783835 true "" "plot pred-sys-profit"

PLOT
845
162
1045
312
Wages
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -11783835 true "" "plot wedex"
"pen-1" 1.0 0 -14070903 true "" "plot wedg"
"pen-2" 1.0 0 -15637942 true "" "plot wex"
"pen-3" 1.0 0 -14439633 true "" "plot wg"

PLOT
1068
11
1268
161
Large Companies Who Train
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -15637942 true "" "plot count companies with [mysize = \"big\" and howtrain? = 2]"
"pen-1" 1.0 0 -10022847 true "" "plot count companies with [mysize = \"big\" and howtrain? = 1]"

PLOT
1265
167
1465
317
Completion Ratio
NIL
NIL
0.0
10.0
0.0
1.0
true
false
"" ""
PENS
"default" 1.0 0 -15637942 true "" "plot per-success"

SLIDER
577
486
749
519
TrainingYears
TrainingYears
3
8
3.0
1
1
NIL
HORIZONTAL

SLIDER
589
582
761
615
Horizon
Horizon
3
30
6.0
1
1
NIL
HORIZONTAL

PLOT
1062
325
1262
475
Number of skilled agents
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot no-edex"
"pen-1" 1.0 0 -7500403 true "" "plot no-edg"
"pen-2" 1.0 0 -2674135 true "" "plot no-ex"
"pen-3" 1.0 0 -955883 true "" "plot no-g"

@#$#@#$#@
## WHAT IS IT?

The model investigates the impact of apprenticeship programmes on societies. It considers different trade types and trainer types.

## HOW IT WORKS

The agetns are utilitarian, and each agent optimises its utility function based learnt parametes and its type.

## HOW TO USE IT

Parameter definition:

* NumberOfPotentialTrainees: This indicates the number of potential trainees introduced per iteration.

* Sliders starting with IW: These indicate initial wages. In these sliders Ed/NEd inidcats educated/not educated, and Ad/Ex indicates adequate/excellent work-based skills.

* Prepayment: It is only used for artisans (craft), when slider "Trainer-type" is set to 2 turning this on means that in the society it is a norm to ask for a prepayment.


## THINGS TO NOTICE

(suggested things for the user to notice while running the model)

## THINGS TO TRY

(suggested things for the user to try to do (move sliders, switches, etc.) with the model)

## EXTENDING THE MODEL

(suggested things to add or change in the Code tab to make the model more complicated, detailed, accurate, etc.)

## NETLOGO FEATURES

(interesting or unusual features of NetLogo that the model uses, particularly in the Code tab; or where workarounds were needed for missing features)

## RELATED MODELS

(models in the NetLogo Models Library and elsewhere which are of related interest)

## CREDITS AND REFERENCES

(a reference to the model's URL on the web if it has one, as well as any other necessary credits, citations, and links)
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270
@#$#@#$#@
NetLogo 6.1.1
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180
@#$#@#$#@
0
@#$#@#$#@
